#include <genesis.h>
#include <draw_sjis.h>
#include <res_image.h>

void draw_sjis_text(u16 plan, const char *str, u16 flags, u16 x, u16 y, u8 use_dma)
{
    u16 str_length = strlen(str);//
    u16 pattern = flags & TILE_INDEX_MASK;//p^[e[üʒu
    u16 baseflags = flags & TILE_ATTR_MASK;//l[e[uo^ɃtÖׂɕKv
    u16 i;

    for(i = 0; i < str_length; i++)
    {
        //擪1Byteo
        u8 c = str[i];

        // SpiVtgJISj񐅏܂ł͈͓̔
        if(c >= 0x81 && c <= 0x9F)
        {
            int font_x = ((u8)str[i + 1] - Foot_Byte_Offset) * 16 ;//XWvZ
            int font_y = ((u8)str[i] - Head_Byte_Offset) * 2;//YWvZ

            //p^[e[uɓo^
            VDP_loadTileData( &sjis_font.tiles[font_x + (font_y * Font_Image_Width)], pattern, Font_Cell_Size, use_dma);//㔼
            pattern += Font_Cell_Size;
            VDP_loadTileData( &sjis_font.tiles[font_x + ((font_y + 1) * Font_Image_Width)], pattern, Font_Cell_Size, use_dma);//
            pattern += Font_Cell_Size;

            //l[e[uɓo^
            VDP_fillTileMapRectInc(plan, baseflags | pattern -4, x + i, y, Font_Cell_Size, Font_Cell_Size);

            i++;
        }
    }
}
